manual

rescaler-yuv for use with mjpeg tools.

Jan Panteltje 2002

low pass filter followed by resizer for video streams.
Uses fft and reverse fft package fftw-2.1.3.tar.gz library from:
http://www.fftw.org/
mjpegtools can be found at:
http://mjpeg.sourceforge.net/

resizer-yuv -h
shows command line options.

Calculation of slope
Trying to make a much as possible a smooth cutoff, preventing 'ringing',
this is especially visible at low cutoff frequencies in black areas.

Specification of filter slope frequency:
form A to B is one half period of a sine wave of frequency dfslope,
this is what you enter with the -s  command line flag.
The -f command line flag is the frequency at which the amplitude is 1/2,
in point C.
So the filter starts a bit before that point and ends a bit after that point.
Try flags -l -f 3.5 -s 1 , this creates a low pass 50 % down at 3.5 MHz,
and rolls of smoothly to be 100 % down at 4.0 MHz.
Thats is if I did the math right.
View graph with fixed spacing!

      A                  B
. . . . 
           .
             .
              .
               .
              C .
                 .
                  . 
                   .
                      .
                           . . . .


Example script how to use it:
/test /big/video/in/demux/testcard.mpv -s 3.5 1
This demuxes an mpeg2 stream. and creates a low pass only at 3.5 MHz -6 dB,
with zero output at 4.0 MHz and higher.
Slope starts at 3.0 MHz.
Then the yuv stream is made into an mpeg2 file again. 
If you leave out the '-l' flag, it also resizes AFTER the low pass to
352x576.
The input format used for this test was 720x576 PAL from DVB-s (digital
satellite).


#script 'test'
cat $1 | \
mpeg2dec \
-o YUV \
$2 \
| \
./resizer-yuv \
-x 352 \
-y 576 \
-l \
-f $3 \
-s $4 \
- g \
| \
mpeg2enc \
--video-bitrate 2500 \
--interlace-mode 1 \
--video-buffer 230 \
--min-gop-size 6 \
--max-gop-size 15 \
--reduction-4x4 1 \
--reduction-2x2 1 \
--quantisation 5 \
--frame-rate 3 \
--aspect 2 \
--format 3 \
--video-norm p \
--playback-field-order t \
-o ./test1.mpg


Burst mask: -b command line option.
This allows you to blank out possible color burst remnants (that could
appear as a vertical line at the most left).
Try -b 10 for making the most left 10 pixels of each line black.
This is applied BEFORE fft and resizing.

-g option:
This does make the slope go down based on a logarithmic (base 10) frequency
scale, as all in this program, this is fully experimental.

Test script, to see the effect ('ringing') that can occur if you use to
steep a curve:

y4mcolorbars -F 50:1  -I b -n 100 -W 720 -H 576 \
| \
resizer-yuv -x 352 -y 576 -f 3.5 -s 1 -g \
|
mpeg2enc \
--video-bitrate 2500 \
--interlace-mode 1 \
--video-buffer 230 \
--min-gop-size 6 \
--max-gop-size 15 \
--reduction-4x4 1 \
--reduction-2x2 1 \
--quantisation 3 \
--frame-rate 3 \
--aspect 2 \
--format 3 \
--video-norm p \
--playback-field-order t \
-o ./q1.mpg

xine -pgfhq q1.mpg

Making -s 1 smaller will increase 'ringing' (the ripples in the picture).
This will also happen if you omit '-g' or make the cutoff frequency lower.

One problem is NTSC, when you use a lower horizontal size, say 480,
there will be less points after the ft, and somehow ringing increases 
considerably.
This all needs to be looked at.

